#!/usr/bin/python

import socket
import sys
import struct
import subprocess
import re

print '########## TFir Server start ##########'

HOST = ''   # Symbolic name meaning all available interfaces
PORT = 1414 # Arbitrary non-privileged port
 
# Datagram (udp) socket
try :
	s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
	print 'Socket created'
except socket.error, msg :
	print 'Failed to create socket. Error Code : ' + str(msg[0]) + ' Message ' + msg[1]
	sys.exit()
 
 
# Bind socket to local host and port
try:
	s.bind((HOST, PORT))
except socket.error , msg:
	print 'Bind failed. Error Code : ' + str(msg[0]) + ' Message ' + msg[1]
	sys.exit()
	 
print 'Socket bind complete'
 
#now keep talking with the client
while 1:

	# receive data from client (data, addr)
	d = s.recvfrom(1024)
	data = d[0]
	addr = d[1]
	 
	if not data: 
		break
 
	tfir_start = 0
	tfir_seq = -1
	tfir_cmd = 0
	length = len(data)

	if ( length > 3 ):

		tfir_start, tfir_seq, tfir_cmd = struct.unpack('3B', data[:3])

		#print 'start: %(b1)02x seq: %(b2)02x cmd: %(b3)02x' % {"b1": tfir_start, "b2": tfir_seq, "b3": tfir_cmd} 

		if (tfir_start == 2):

			if ((tfir_cmd == 36) & (length == 8)) | ((tfir_cmd == 42) & (length == 14)):
				# Power Status Request (MAC)

				ip0, ip1, ip2, ip3 = struct.unpack('4B', data[3:7])

				#print 'ip: %(ip0)d.%(ip1)d.%(ip2)d.%(ip3)d' % {"ip0": ip0, "ip1": ip1, "ip2": ip2, "ip3": ip3} 

				host = '%(ip0)d.%(ip1)d.%(ip2)d.%(ip3)d' % {"ip0": ip0, "ip1": ip1, "ip2": ip2, "ip3": ip3}
				
				if (tfir_cmd == 36):
					print '<- PowerStatusRequest for: ' + host
				else:
					print '<- PowerStatusRequestMAC for: ' + host

				# fping the toppy
				
				power_status = 0
				
				fping = subprocess.Popen(
					["fping", "-c1", "-t250", "-q", host],
					stdout = subprocess.PIPE,
					stderr = subprocess.PIPE
				)

				out1, out2 = fping.communicate()
				#print 'out1: ' + out1
				#print 'out2: ' + out2

				match = re.search("loss = (\d)\/(\d)", out2)
				if match:
					#print match.group(1) + ',' + match.group(2)
					if ( match.group(1) == match.group(2) ):
						power_status = 1
				else:
					print '!!! loss = (\d)\/(\d) not found'

				if power_status:
					print '-> Toppy is on'
				else:
					print '-> Toppy is off'

				# send response				 STX	, SEQ		, ok, len, payload		, ETX
				response = struct.pack('6B', 2		, tfir_seq	, 0	, 1	 , power_status	, 3)

				#print 'response: ' + repr(response)
	 
				s.sendto(response, addr)

			elif (tfir_cmd == 21) & ( length == 9 ):
				# TfirCmd_SendNECRemote2

				ir0, ir1, ir2, ir3 = struct.unpack('4B', data[4:8])

				#print 'IR: %(ir0)02x%(ir1)02x %(ir2)02x%(ir3)02x' % {"ir0": ir0, "ir1": ir1, "ir2": ir2, "ir3": ir3} 

				remote = '%(ir0)02x%(ir1)02x' % {"ir0": ir0, "ir1": ir1}
				code   = '%(ir2)02x%(ir3)02x' % {"ir2": ir2, "ir3": ir3}

				print '<- TfirCmd_SendNECRemote2: 0x' + remote + code
				print '=> irsend SEND_ONCE tfir' + remote + ' k' + code
	 
				irsend = subprocess.Popen(
					["irsend", "SEND_ONCE", 'tfir' + remote, 'k' + code],
					stdout = subprocess.PIPE,
					stderr = subprocess.PIPE
				)

				out, error = irsend.communicate()
				#print out
				#print error

				# send response				 STX	, SEQ		  ok, len, ETX
				response = struct.pack('5B', 2		, tfir_seq	, 0	, 0  , 3)
	
				#print 'response: ' + repr(response)
	 
				s.sendto(response, addr)

			else:

				print '!!! unknown request' 
				print 'start: %(b1)02x seq: %(b2)02x cmd: %(b3)02x' % {"b1": tfir_start, "b2": tfir_seq, "b3": tfir_cmd} 
				print 'data-length: %(l)d' % { "l": len(data) }
				print 'Message[' + addr[0] + ':' + str(addr[1]) + '] - ' + repr(data)

		else:

			print '!!! invalid pack start byte' 
			print 'start: %(b1)02x seq: %(b2)02x cmd: %(b3)02x' % {"b1": tfir_start, "b2": tfir_seq, "b3": tfir_cmd} 
			print 'data-length: %(l)d' % { "l": len(data) }
			print 'Message[' + addr[0] + ':' + str(addr[1]) + '] - ' + repr(data)
		
	else:

		print '!!! invalid data-length: %(l)d' % { "l": length }
		print 'Message[' + addr[0] + ':' + str(addr[1]) + '] - ' + repr(data)
	 
s.close()